
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何用Java编写一个简单的服务器和客户机 / 憋错料</title>

    <meta name="description" content="如何用Java编写一个简单的服务器和客户机 今天我要向大家介绍的是自己编写的一个比较简单的服务器和客户机程序,注意一下哦,比较简单.好了,闲话休提,砸门直入主题. 小编先从客户机和服务器的模型开始讲解.简单来说,我们实现的这种模型呢,我们每一个用户称为一个客户机,用户之间的通信之间需要一个中转,所有客户机的通信都依托于这个中转,很明显,这个中转,就是砸门的服务器了.整个模型比较简单明了,那么,接下来我们就直接进入实现阶段. 我们从实现服务器开始.Java提供了这样的一个类,ServerSocket.我们通过实例化它的方式来创建一个服务器.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">如何用Java编写一个简单的服务器和客户机</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>今天我要向大家介绍的是自己编写的一个比较简单的服务器和客户机程序，注意一下哦，比较简单。好了，闲话休提，砸门直入主题。</p>
<p>小编先从客户机和服务器的模型开始讲解。简单来说，我们实现的这种模型呢，我们每一个用户称为一个客户机，用户之间的通信之间需要一个中转，所有客户机的通信都依托于这个中转，很明显，这个中转，就是砸门的服务器了。整个模型比较简单明了，那么，接下来我们就直接进入实现阶段。</p>
<p>我们从实现服务器开始。Java提供了这样的一个类，ServerSocket。我们通过实例化它的方式来创建一个服务器。注意一下，创建服务器需要一个参数port。port指的是端口号。我们知道一台计算机上运行着许多程序，那么，对于另一台计算机来说，它想要连接到这台服务器的这个程序，该如何区分呢？首先当然是根据IP连接到这台计算机，那么，然后呢？对的，你没有想错，就是通过我们的port端口号了。正常情况下，计算机会自动我们创建的程序分配一个port，但是，因为我们创建的是提供给别的计算机连接的服务器，所以我们需要指定一个端口号供给外部计算机连接。注意一下，计算机有的端口号已经被其他程序占用了，要想查看，你可以通过在cmd命令行输入netstat -an来查询。在这里，我们给定我们的端口号为空闲的9999。</p>
<pre> 1     public static void main(String[] args) {
 2         new Server().CreateServer(9999);
 3     }
 4     public void CreateServer(int port){
 5         try {
 6             ServerSocket serversocket = new ServerSocket(port);
 7         } catch (IOException e) {
 8             e.printStackTrace();
 9         }
10     }</pre>
<p>接下来，我们让服务器进入等待客户机连接的状态。通过查看ServerSocket源码我们会发现，它里面有一个accept方法，其返回值是Socket类型。</p>
<pre>1 Socket socket = serversocket.accept();</pre>
<p>Socket是Java中的另一个用于通信的类， 我们称它为套接字。事实上，小编是这样看的，Socket相当于建立在服务器和客户端之间的一根通道。我们可以从socket获取它的输入输出流对象，也就是我们的InputStream和OutputStream。这两个输入输出都是采用字节传输的方法，如果你想要读取一行数据可以通过BufferReader bufferreader =&nbsp;new BufferedReader(new InputStreamReader(is))的方式，将InputStream转化成bufferRead之后调用readLine方法就可以了。需要注意的是对于readLine这个方法，/r/n表示消息的读取结束。因此需要对消息进行+“/r/n”的操作来保证读取的正常进行。</p>
<p>因为在等待客户机连接的时候，程序进入阻塞状态，这个时候程序无法进行下去，而且，这样的写法也只能够供给一个客户机连接。为了能够实现简单客户机和服务器的对话，我们需要采用多线程的方式去实现它，并且将实例化socket对象以及之后的这部分代码放入到while循环当中。为了能够实现客户机与客户机的通信，我们建立了一个消息处理类，并且实例化了一个数组队列去存储它，然后将这个队列作为消息处理类的一个属性。这样所有的问题就得到了完美的解决。</p>
<pre> 1     public void creatserver(int port) {
 2         try {
 3             ServerSocket serversocket = new ServerSocket(port);
 4             System.out.println("服务器已经开启,正在等待客户机连接...");
 5             while (true) {
 6                 Socket sk = serversocket.accept();
 7                 chatMessage cm = new chatMessage(sk, list);
 8                 list.add(cm);
 9                 cm.start();
10             }
11         } catch (IOException e) {
12             e.printStackTrace();
13         }
14     }</pre>
<p>消息处理类当中的内容，主要是实现对消息的封装处理等等，以及对消息的鉴别。诸如消息是群发还是私发，如果是群发，那么遍历整个消息处理类的队列，如果是私发，那么同样需要遍历整个队列去寻找我们需要私发的用户名，然后将消息传给它。一些其他的注意就不再赘述了，小编在代码中也给出了相应的注释，特别提出一点，当socket关闭，连接断开，我们同样需要关闭我们的IO流，否则占用资源是比较严重的。</p>
<pre>  1 public class chatMessage extends Thread {
  2     // 客户机的账号
  3     public String username;
  4     // 客户机的密码
  5     public String password;
  6     // // 客户机的开启状态
  7     // public volatile boolean state;
  8     // 客户机对象
  9     public Socket s;
 10     // 客户机的输入流
 11     public InputStream is;
 12     // 客户机的输出流
 13     public OutputStream os;
 14     // 缓冲(读一行数据)
 15     public BufferedReader br;
 16     // 存储所有客户机对象的数组队列
 17     public ArrayList&lt;chatMessage&gt; list;
 18
 19     /**
 20      * chatMessage的构造方法，包括IO流的建立
 21      *
 22      * @param s
 23      *            Socket对象
 24      * @param list
 25      *            存储chatMessage对象的数组队列
 26      * @throws IOException
 27      *             抛出IO异常
 28      */
 29     public chatMessage(Socket s, ArrayList&lt;chatMessage&gt; list)
 30             throws IOException {
 31         this.s = s;
 32         this.list = list;
 33         is = s.getInputStream();
 34         os = s.getOutputStream();
 35         br = new BufferedReader(new InputStreamReader(is));
 36     }
 37
 38     /**
 39      * 服务器转发消息
 40      *
 41      * @param str
 42      *            转发的消息内容
 43      * @throws IOException
 44      *             抛出IO异常
 45      */
 46     public void sendMessage(String str) throws IOException {
 47         os.write((str + "\r\n").getBytes());
 48     }
 49
 50     /**
 51      * 服务器把消息广播到所有的客户机
 52      *
 53      * @param str
 54      *            广播的消息内容
 55      * @param code
 56      *            消息类型的判断，1表示为提示成员登录，2表示为广播消息
 57      * @throws IOException
 58      *             抛出的IO异常
 59      */
 60     public void sendAllMessage(String str, int code) throws IOException {
 61         for (int index = 0; index &lt; list.size(); index++) {
 62             if (list.get(index) != this &amp;&amp; code == 1) {
 63                 list.get(index).sendMessage(str);
 64             } else if (code == 2) {
 65                 list.get(index).sendMessage(str);
 66             }
 67         }
 68         System.out.print(str + "\r\n");
 69     }
 70
 71     /**
 72      * 读取来自客户端的消息
 73      *
 74      * @return 返回一个字符串
 75      * @throws IOException
 76      *             抛出IO异常
 77      */
 78     public String readMessage() throws IOException {
 79         return br.readLine();
 80     }
 81
 82     /**
 83      * 服务器把消息转发给某人
 84      *
 85      * @param str1
 86      *            消息内容
 87      * @param str2
 88      *            消息的接收人
 89      */
 90     public void sendMessageToOthers(String str1, String str2) {
 91         for (int i = 0; i &lt; list.size(); i++) {
 92             if (str2.equals(list.get(i).username)) {
 93                 try {
 94                     list.get(i).sendMessage(str1);
 95                 } catch (IOException e) {
 96                     e.printStackTrace();
 97                 }
 98             }
 99         }
100     }
101
102     /**
103      * 线程启动 从客户机获取登录信息,分别赋给username以及password 给对应客户机发送“欢迎来到聊天室”
104      * 给所有的客户机发送username+“来到聊天室”
105      *
106      *
107      *
108      *
109      *
110      *
111      */
112     public void run() {
113         try {
114             String str = readMessage();
115             makeMessage(str);
116             sendMessage("欢迎来到聊天室");
117             String string = username + "来到聊天室";
118             sendAllMessage(str, 1);
119             String s;
120             while (!(s = readMessage()).equals("bye")) {
121                 if (s.charAt(0) == ‘@‘) {
122                     int nig = s.indexOf(" ");
123                     String ns = s.substring(1, nig);
124                     String valuestring = s.substring(nig + 1, s.length());
125                     for (int j = 0; j &lt; list.size(); j++) {
126                         if (ns.equals(list.get(j).username)) {
127                             list.get(j).sendMessage(
128                                     username + "对你说:" + valuestring);
129                         }
130                     }
131                 } else {
132                     s = username + "说:" + s;
133                     sendAllMessage(s, 2);
134                 }
135             }
136             sendAllMessage(username + "离开了聊天室", 1);
137             close();
138         } catch (IOException e) {
139             e.printStackTrace();
140         }
141     }
142
143     /**
144      * 关闭所有IO
145      *
146      * @throws IOException
147      *             抛出IO异常
148      */
149     public void close() throws IOException {
150         is.close();
151         os.close();
152         br.close();
153         s.close();
154     }
155
156     /**
157      * 对首次登录时客户机发送的登录信息进行处理,给username以及password赋值
158      *
159      * @param str
160      *            首次登录客户机发送的信息
161      */
162     public void makeMessage(String str) {
163         int index = str.indexOf(",");
164         username = str.substring(0, index);
165         password = str.substring(index + 1, str.length());
166     }
167 }</pre>
<p>客户端的编写跟服务器差不多，主要需要注意的一些内容上的匹配，比如小编的服务器首先需要进行一次对账号密码内容的接收，也就是说需要读取一条消息后正常进行。小编稍微加了一点界面内容，比较简单，所以也比较一般，大家稍微看看，不必过多在意界面的内容。</p>
<p>这个是登录界面的代码:</p>
<pre> 1 package Client0802;
 2
 3 import java.awt.Dimension;
 4 import java.awt.FlowLayout;
 5 import java.awt.Font;
 6
 7 import javax.swing.JButton;
 8 import javax.swing.JFrame;
 9 import javax.swing.JLabel;
10 import javax.swing.JPasswordField;
11 import javax.swing.JTextField;
12
13 public class Login extends JFrame {
14     public static void main(String[] args) {
15         new Login().initUI();
16     }
17
18     public void initUI() {
19         this.setTitle("Login");
20         this.setSize(350, 300);
21         this.setLayout(new FlowLayout());
22         this.setLocationRelativeTo(null);
23         this.setDefaultCloseOperation(3);
24         Dimension dim1 = new Dimension(100, 60);
25         Dimension dim2 = new Dimension(200, 60);
26         Font font = new Font("宋体", Font.BOLD, 20);
27         JLabel jlone = new JLabel("账号 :");
28         jlone.setPreferredSize(dim1);
29         jlone.setFont(font);
30         this.add(jlone);
31         JTextField jtf = new JTextField();
32         jtf.setPreferredSize(dim2);
33         jtf.setFont(font);
34         this.add(jtf);
35         JLabel jltwo = new JLabel("密码 :");
36         jltwo.setPreferredSize(dim1);
37         jltwo.setFont(font);
38         this.add(jltwo);
39         JPasswordField jpwf = new JPasswordField();
40         jpwf.setPreferredSize(dim2);
41         jpwf.setFont(font);
42         this.add(jpwf);
43         JButton jbt = new JButton("登录");
44         jbt.setPreferredSize(new Dimension(80, 40));
45         this.add(jbt);
46
47         this.setVisible(true);
48         listener lis = new listener(this, jtf, jpwf);
49         jbt.addActionListener(lis);
50     }
51
52     public static void Log(String str) {
53         System.out.println(str);
54     }
55 }</pre>
<p>这个是处理点击登录的监听器:</p>
<pre>  1 package Client0802;
  2
  3 import java.awt.Dimension;
  4 import java.awt.FlowLayout;
  5 import java.awt.TextArea;
  6 import java.awt.event.ActionEvent;
  7 import java.awt.event.ActionListener;
  8 import java.io.BufferedReader;
  9 import java.io.IOException;
 10 import java.io.InputStream;
 11 import java.io.InputStreamReader;
 12 import java.io.OutputStream;
 13 import java.net.Socket;
 14 import java.net.UnknownHostException;
 15
 16 import javax.swing.JButton;
 17 import javax.swing.JFrame;
 18 import javax.swing.JPasswordField;
 19 import javax.swing.JTextField;
 20
 21 public class listener implements ActionListener {
 22     public JFrame jf;
 23     public JFrame newjf;
 24     public InputStream is;
 25     public OutputStream os;
 26     public BufferedReader br;
 27     public JTextField jtf, cou;
 28     public JPasswordField jpwf;
 29
 30     public listener(JFrame jf, JTextField jtf, JPasswordField jpwf) {
 31         this.jf = jf;
 32         this.jtf = jtf;
 33         this.jpwf = jpwf;
 34     }
 35
 36     /*
 37      * 实例化客户机，连接到服务器 实例化IO流 将得到的账户和密码发送给服务器 关闭原有登录界面 建立一个显示界面
 38      */
 39     public void actionPerformed(ActionEvent e) {
 40         try {
 41             Socket s = new Socket("127.0.0.1", 7777);
 42             System.out.print("连接到了服务器");
 43             is = s.getInputStream();
 44             os = s.getOutputStream();
 45             br = new BufferedReader(new InputStreamReader(is));
 46             String s1 = jtf.getText();
 47             String s2 = String.valueOf(jpwf.getPassword());
 48             sendMessage(s1 + "," + s2 + "\r\n");
 49             jf.dispose();
 50             newjf = new JFrame();
 51             newjf.setTitle("communication...");
 52             newjf.setSize(800, 600);
 53             newjf.setLocationRelativeTo(null);
 54             newjf.setDefaultCloseOperation(3);
 55             newjf.setLayout(new FlowLayout());
 56             TextArea ta = new TextArea();
 57             ta.setPreferredSize(new Dimension(790, 300));
 58             newjf.add(ta);
 59             cou = new JTextField();
 60             cou.setPreferredSize(new Dimension(700, 150));
 61             newjf.add(cou);
 62             JButton jb = new JButton("发送");
 63             jb.setPreferredSize(new Dimension(80, 150));
 64             newjf.add(jb);
 65             newjf.setVisible(true);
 66             getMessage gm = new getMessage(br, ta);
 67             gm.start();
 68             jb.addActionListener(new ActionListener() {
 69                 public void actionPerformed(ActionEvent e) {
 70                     try {
 71                         os.write((cou.getText() + "\r\n").getBytes());
 72                         cou.setText("");
 73                     } catch (IOException e1) {
 74                         e1.printStackTrace();
 75                     }
 76                 }
 77             });
 78         } catch (UnknownHostException e1) {
 79             e1.printStackTrace();
 80         } catch (IOException e1) {
 81             e1.printStackTrace();
 82         }
 83     }
 84
 85     /**
 86      * 发送消息到服务器
 87      *
 88      * @param str
 89      */
 90     public void sendMessage(String str) {
 91         try {
 92             os.write(str.getBytes());
 93         } catch (IOException e) {
 94             e.printStackTrace();
 95         }
 96     }
 97
 98     /**
 99      * 初始化一个显示界面
100      */
101     public void initUI() {
102         newjf = new JFrame();
103         newjf.setTitle("communication...");
104         newjf.setSize(800, 600);
105         newjf.setLocationRelativeTo(null);
106         newjf.setDefaultCloseOperation(3);
107         newjf.setLayout(new FlowLayout());
108         TextArea ta = new TextArea();
109         ta.setPreferredSize(new Dimension(790, 300));
110         newjf.add(ta);
111         cou = new JTextField();
112         cou.setPreferredSize(new Dimension(700, 150));
113         newjf.add(cou);
114         JButton jb = new JButton("发送");
115         jb.setPreferredSize(new Dimension(80, 150));
116         newjf.add(jb);
117         jb.addActionListener(new ActionListener() {
118             public void actionPerformed(ActionEvent e) {
119                 try {
120                     os.write((cou.getText() + "\r\n").getBytes());
121                     cou.setText("");
122                 } catch (IOException e1) {
123                     e1.printStackTrace();
124                 }
125             }
126         });
127         newjf.setVisible(true);
128         boolean temp = true;
129         while (temp) {
130             temp = false;
131             getMessage gm = new getMessage(br, ta);
132             gm.start();
133         }
134     }
135 }</pre>
<p>这个是用于控制接收服务器消息的线程类:</p>
<pre> 1 package Client0802;
 2
 3 import java.awt.TextArea;
 4 import java.io.BufferedReader;
 5 import java.io.IOException;
 6
 7 public class getMessage extends Thread {
 8     public BufferedReader br;
 9     public TextArea ta;
10
11     public getMessage(BufferedReader br, TextArea ta) {
12         this.br = br;
13         this.ta = ta;
14     }
15
16     public void run() {
17         while (true) {
18             try {
19                 String str = br.readLine();
20                 if (str != null &amp;&amp; str != "") {
21                     ta.append(str + "\n");
22                 }
23             } catch (IOException e) {
24                 e.printStackTrace();
25             }
26         }
27     }
28 }</pre>
<p>大概内容就这么多拉，其实小编还有很多内容没有设计到，比如说发送图片啊，比如说文件的传输啊，这些都还没有动手实现，但是，整个过程其实都差不太多，只是传输用到的IO流类名不太一样而已，这不是什么大问题。我相信以大家的聪明才智都能够解决！最后小编将就通信协议这一块稍微做一点总结。</p>
<p>协议是什么。协议是指双方共同设计的必须满足的要求。在通信这一块，在客户机服务器模型这一块，就是指规定消息的编写格式。这也就是为什么小编之前说的编写客户机和服务器的内容查差不了多少了。对于一个完整的通信系统来说，协议非常重要，就像老师群发了一封邮件给所有人，但是，邮件是用日语写的，大家看不懂，这就是导致的后果。协议也一样，客户机给服务器发送许许多多的字节，服务器无法区分有几部分，每一部分是什么意思，那么，服务器就无法对消息进行处理。就像一段暗号或者说是密文，你可以这么去定义你的协议，比如，消息的第几个字节表示什么，消息第几个字节到第几个字节代表什么。当然这还是比较简单的通信协议，各位看官可以去网上查一查那些比较有名的软件的协议，QQ、微信等等。当然，有一些软件的协议是不公开的。</p>
<p>东西就讲到这啦，小编最近在写一个安卓的客户端，估摸着也差不太多，欢迎下次再来！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:05:17 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%87%aa%e5%b7%b1/" title="自己">自己</a>, <a href="https://www.biecuoliao.com/tag/lis/" title="lis">lis</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%a6%e4%b8%80%e4%b8%aa/" title="另一个">另一个</a>, <a href="https://www.biecuoliao.com/tag/write/" title="write">write</a>, <a href="https://www.biecuoliao.com/tag/while/" title="while">while</a>, <a href="https://www.biecuoliao.com/tag/try/" title="try">try</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%91%e9%80%81/" title="发送">发送</a>, <a href="https://www.biecuoliao.com/tag/%e9%98%9f%e5%88%97/" title="队列">队列</a>, <a href="https://www.biecuoliao.com/tag/%e8%81%8a%e5%a4%a9%e5%ae%a4/" title="聊天室">聊天室</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>如何用Java编写一个简单的服务器和客户机的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jx1AB0.html" rel="bookmark">Python 使用Socket模块编写一个简单的服务器和客户端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				任务 Socket套接字开始监听后,使用accept函数来等待客户连接.这个过程在循环中无限循环,服务器处理完和客户端的连接后会再次调用accpet函数,等待下一个连接. 客户端代码 1 import socket 2 s1=socket.socket() 3 s1.bind((&quot;127.0.0.1&quot;,2345)) 4 s1.listen(5) 5 while 1: 6 conn,address = s1.accept() 7 print(&quot;a new connect fro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a5mKk0.html" rel="bookmark">如何用VBS编写一个简单的恶搞脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				windows系统的电脑, 首先右击桌面,选择新建-文本文档,在桌面上新建一个文本文档: 随后打开计算机或者是我的电脑,点击其中的组织(xp系统多为工具),选择下面的文件夹和搜索选项 在弹出的窗口中点击查看,向下滚到,找到隐藏已知文件类型的扩展名,点掉勾号,然后确定: 此时发现新建的文本文档出现后缀名为.txt 打开文本文档后,输入: msgbox&quot;傻X&quot;,后保存. 修改文本文档的后缀,将.txt改为.vbs,后确定,双击打开.窗口弹出如图所示窗口,点确定或关闭后消失. 如果想添加一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r2aKb3.html" rel="bookmark">用nodejs搭建一个简单的服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用nodejs搭建一个简单的服务器 nodejs优点:性能高(读写文件) 数据操作能力强 官网:www.nodejs.org 验证是否安装成功:cmd命令行中输入node -v 如果显示版本号表示安装成功 [常用命令] 切换盘符 d:进入文件夹 cd nodejs返回上一级目录 cd..清屏 cls展示目录 dir复制文件名 选中右键--复制历史操作 上箭头 执行文件 node 文件名(在文件文件夹目录中)停止命令行 ctrl+c nodejs可以使用的ECMAScript.读写文件.数据库操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kZYkLM.html" rel="bookmark">手把手教你编写一个简单的PHP模块形态的后门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看到Freebuf 小编发表的用这个隐藏于PHP模块中的rootkit,就能持久接管服务器文章,很感兴趣,苦无作者没留下PoC,自己研究一番,有了此文 0×00. 引言 PHP是一个非常流行的web server端的script语言.目前很多web应用程序都基于php语言实现.由于php是个开源软件并易于扩展,所以我们可以通过编写一个PHP模块(module 或者叫扩展 extension)来实现一个Backdoor. 本文就简单介下如何一步步编写一个简单的php 动态扩展后门. 0×01. p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qE6WD3.html" rel="bookmark">编写一个简单的jdbc例子程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 package it.cast.jdbc; 2 3 import java.sql.Connection; 4 import java.sql.DriverManager; 5 import java.sql.ResultSet; 6 import java.sql.SQLException; 7 import java.sql.Statement; 8 9 public class Base { 10 11 public static void main(String[] args) th			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QwJNE0.html" rel="bookmark">利用java实现一个简单的远程监控程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般的远程监控软件都是用c或者c++等语言开发的,而使用java如何来实现相同的功能呢. 首先我们先介绍一下一个简单的远程监控程序的实现原理. 功能一,远程屏幕监视 (1) 必须要有监控端与被监控端,而且程序保持启动. (2) 被监控端获取本机的屏幕截屏发图给监控端. (3) 监控端在本地窗口中显示被监控端发送过来的图像. (4) (2)(3)步骤重复执行,这时在监控端即可实时监视到被监控端的桌面操作了. 功能二,远程控制 (1) 必须要有监控端与被监控端,而且程序保持启动. (2) 在监控端监			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pLZdg4.html" rel="bookmark">编写一个简单的javaEE加法程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一 .javaEE的安装及环境配置 工具: 32位系统准备eclipse-jee-mars-2-win32.zip,64位系统准备eclipse-jee-mars-2-win32-x86_64.zip jdk1.7 maven3.3.9.rar m2.rar 环境配置: 1. 设置eclipse的配置文件eclipse.ini,修改虚拟机路径,在-vmargs之前添加 -vm E:\jee\jdk1.7\bin\javaw.exe 注意:用写字板打开修改,-vm有的电脑要换行,有的电脑不用换行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6gxGy0.html" rel="bookmark">多线程编程学习笔记&mdash;&mdash;编写一个异步的HTTP服务器和客户端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				接上文 多线程编程学习笔记——使用异步IO 二.   编写一个异步的HTTP服务器和客户端 本节展示了如何编写一个简单的异步HTTP服务器. 1.程序代码如下. using System; using System.Collections.Generic; using System.IO; using System.Linq; using System.Net; using System.Net.Http; using System.Text; using System.Threading.Ta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bYg1YM.html" rel="bookmark">【C&plus;&plus;】编写一个简单的类。包含构造函数，成员函数等。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;pre name=&quot;code&quot; class=&quot;cpp&quot;&gt;//编写一个简单的类.包含构造函数,成员函数等. #include &lt;iostream&gt; using namespace std; class Rec { public: Rec(int l,int w); int Area(); void Print(); private: int length,wide; }; Rec::Rec(int l,int w) { length=l; w			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aDgnM.html" rel="bookmark" class="title">HAProxy 高级应用（一）</a>
					<div>
						HAProxy 高级应用 ================================================================================ 概述:    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vAbZ0.html" rel="bookmark" class="title">Codeforces 837D Round Subset（背包）</a>
					<div>
						题目链接  Round Subset 题意  在n个数中选择k个数,求这k个数乘积末尾0个数的最大值. 首先我们预处理出每个数5的因子个数c[i]和2的因子个数d[i] 然后就可以背包了. 设f[i] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoOPDM.html" rel="bookmark" class="title">作业1：简单博客练习</a>
					<div>
						(1)介绍自己:我是来自网工141的袁晨晖,学号是1413042017,      个人兴趣:听歌,玩电脑,打篮球. (2)介绍自己的Github 注册流程:  ①打开GitHub登录界面,点击Sig ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5Bd70.html" rel="bookmark" class="title">UI基础----常见控件的使用之TextView</a>
					<div>
						TextView TextView是最简单的一个控件,主要用于在界面上显示一段文本信息. TextView的一些属性: gravity:指定文字的对齐方式,可选值有top.bottom.left.ri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBm6BJ4.html" rel="bookmark" class="title">MS MDS系列之初识MS Master Data Service&lpar;微软主数据服务&rpar;</a>
					<div>
						背景介绍: 主数据服务(Master Data Services)是微软平台支持的主数据管理(MDM)平台.类似MDS这样的系统,如果后续维护得当,会给企业提供一个强大的中心数据库系统,来防止企业数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAeJy4.html" rel="bookmark" class="title">java之线程飞机大战制作</a>
					<div>
						import java.awt.Graphics; import java.util.ArrayList; import javax.swing.JFrame; import javax.swing. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kD5QX3.html" rel="bookmark" class="title">難 得 好 天</a>
					<div>
						  ..   ..     .. 觀夕陽雀巧入簾海山雲兮桑田抱得碩瓜汁滿甜  難  得  好  天  墾丁誠品華蓮 ..     &lt;*&gt;七秒   --------------------  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRXpQ4.html" rel="bookmark" class="title">C&plus;&plus; 重构 markdown&amp;ndash&semi;&amp;gt&semi; HTML 的引擎</a>
					<div>
						  之前正好刚用python写了一个简单的scheme解释器,出于对于python中模式匹配和字符串处理的顺手,用python做了之前的那个转换引擎. 但代码结构自己是很不满意的,但对于python的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRjdqM.html" rel="bookmark" class="title">&lbrack;ionic开源项目教程&rsqb; - 第3讲 左右滑动菜单的实现&lpar;使用Tabs和SlideBox&rpar;</a>
					<div>
						使用Tabs和SlideBox实现左右滑动菜单 1.将tab1.html的代码改为如下: &lt;ion-view view-title=&quot;健康&quot;&gt;  &lt;ion-con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5qaW3.html" rel="bookmark" class="title">近期学习Java的收获</a>
					<div>
						1.系统不仅要花费时间来创建对象,而且要花时间对这些对象进行垃圾回收和处理,所以应尽量避免过多过常的创建对象,可用基本数据类型或数组来替代对象: 2. 当某个对象被定义为static变量所引用,这个对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglngL0.html" rel="bookmark" class="title">外键约束的作用</a>
					<div>
						外键是该表是另一个表之间联接的字段 外键必须为另一个表中的主键 外键的用途是确保数据的完整性.它通常包括以下几种: 1 实体完整性,确保每个实体是唯一的(通过主键来实施) 2 域完整性,确保属性值只从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b5B69M.html" rel="bookmark" class="title">Json解析数据</a>
					<div>
						Json数据解析(重点网址推荐:www.json.org   code.google.com/   https://www.json.com/) 1:什么是Json? 2:Json数据格式的特点? 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRKen4.html" rel="bookmark" class="title">python网络爬虫 新浪博客篇</a>
					<div>
						上次写了一个爬世纪佳缘的爬虫之后,今天再接再厉又写了一个新浪博客的爬虫.写完之后,我想了一会儿,要不要在博客园里面写个帖子记录一下,因为我觉得这份代码的含金量确实太低,有点炒冷饭的嫌疑,就是把上次的代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klXrP3.html" rel="bookmark" class="title">HTML5游戏开发引擎Pixi&period;js新手入门讲解</a>
					<div>
						在线演示 本地下载 ?这篇文章中,介绍HTML5游戏引擎pixi.js的基本使用. 相关代码如下: Javascript 导入类库:(使用极客的cdn服务:http://cdn.gbtags.com) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j95nAM.html" rel="bookmark" class="title">2015年9月21号css1</a>
					<div>
						一.border边框 border:1px solid #F00; border-style:dashed虚线 dotted点点点 边框样式 border-width:3px;边框宽度 border- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvaNkM.html" rel="bookmark" class="title">百度地图api - 城市列表</a>
					<div>
						&lt;!doctype html&gt;&lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6xpdZ3.html" rel="bookmark" class="title">WEB （html）基本的元素</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;title&gt; the page title name &lt;/title&gt; &lt;/head&gt; &lt;body&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQDXe0.html" rel="bookmark" class="title">javaSE第二十七天</a>
					<div>
						第二十七天????447 1:反射(理解)????447 (1)类的加载及类加载器????447 (2)反射:????448 A:定义????448 B:获取字节码对象的三种方式????449 (3) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm7d713.html" rel="bookmark" class="title">开发中异常的处理</a>
					<div>
						/** * 代表的是当前应用程序的进程. */ public class MobliesafeApplication extends Application { public BlackNumberI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLLKWEM.html" rel="bookmark" class="title">Scrum &amp;amp&semi; Agile-in-srm</a>
					<div>
						A framework within which people can address complex adaptive problems, while productively and creati ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
